extern char *malloc(), *realloc();

# line 7 "ingest.y"
static char *SccsId = "@(#)ingest.y 5.1 9/25/91 MLT Robin Boswell Copyright The Turing Institute 1989";

/* Parsing routines for RealID */

#include "mdep.h"

#include <stdio.h>
#include <strings.h>


#define _MC68881<_
#include <math.h>

#include "cn_externs.h"

/* Other C declarations for example reading */

void attr_error(), print_att_value();
int number_of_errors;
EList example_list;
EList *e_ptr;
EList *ex_ptr_array;

List attribute_list, new_list, tree_att_list;
List *attr_ptr;

binary_action default_binary_flag, current_binary_flag;

Attribute *IDclass, *current_attr;

int att_num, number_of_attributes, number_of_classes;
BOOL ukdc_flag;
long number_of_examples;
int errflag, ex_errflag;
char temp[BUFSIZ];

/* Other C declarations for tree reading */

int att_val, count_index;


# line 49 "ingest.y"
typedef union {
	int ival;
	float fval;
	char *sval;
} YYSTYPE;
# define STRING 257
# define INTEGER_TOKEN 258
# define FLOAT_TOKEN 259
# define BOTH_FILE_HEADER 260
# define ATTRIBUTE_FILE_HEADER 261
# define EXAMPLE_FILE_HEADER 262
# define TREE_FILE_HEADER 263
# define RULE_FILE_HEADER 264
# define ORDERED_RULE_TOKEN 265
# define UNORDERED_RULE_TOKEN 266
# define BEFORE_TOKEN 267
# define ORDERING_TOKEN 268
# define IF_TOKEN 269
# define THEN_TOKEN 270
# define AND_TOKEN 271
# define ELSE_TOKEN 272
# define DEFAULT_TOKEN 273
# define BINARY_TOKEN 274
# define MULTIPLE_TOKEN 275
# define DONT_CARE 276
# define UNKNOWN 277
# define FLOAT_TYPE 278
# define INTEGER_TYPE 279
# define SEPARATOR 280
# define COLON 281
# define EOE_CHAR 282
# define LEQ 283
# define GE 284
# define LE 285
# define EQUALS 286
# define NULL_DECISION 287
# define CLASH_DECISION 288
# define OPEN_PARENTHESIS 289
# define CLOSE_PARENTHESIS 290
# define OPEN_BRACKET 291
# define CLOSE_BRACKET 292
# define OPEN_SQUARE 293
# define CLOSE_SQUARE 294
# define W_TOKEN 295
#define yyclearin yychar = -1
#define yyerrok yyerrflag = 0
extern int yychar;
extern int yyerrflag;
#ifndef YYMAXDEPTH
#define YYMAXDEPTH 150
#endif
YYSTYPE yylval, yyval;
# define YYERRCODE 256

# line 789 "ingest.y"


#include "lex.yy.c"
yywrap()
{
     return(1);
}


void attr_error(ln, att_num, entry)
long ln;
int att_num;
char *entry;
{    errflag = TRUE;
     fprintf(stdout, "ERROR: Inappropriate value for attribute ");
     fprintf(stdout, "%d\n", att_num);
     fprintf(stdout, " ->  %s\n", entry);          
     fprintf(stdout, "Line number: %d\n", ln);
}

void dc_error(ln)
long ln;
{    errflag = TRUE;
     fprintf(stdout, "\nERROR: \"Don't Care\" is not a  permitted ");
     fprintf(stdout, "class value!\n");
     fprintf(stdout, "Line number: %d\n", ln);
}

void uk_error(ln)
long ln;
{    errflag = TRUE;
     fprintf(stdout, "\nERROR: \"Unknown\" is not a permitted ");
     fprintf(stdout, "class value!\n");
     fprintf(stdout, "Line number: %d\n", ln);
}


     
attr_num_error(ln, att_num, number_of_attributes)
long ln;
int att_num, number_of_attributes;
{
     errflag = TRUE;
     fprintf(stdout, "ERROR: Wrong number of attributes\n");
     fprintf(stdout, "Line number: %d\n", ln);
     fprintf(stdout, "\tAttributes expected (including class): %d\n", number_of_attributes);
     fprintf(stdout, "\tAttributes found:                      %d\n", att_num+1);
}

     




/* Make into a #define
void print_att_value(stream, attno, value)
FILE *stream;
Attval value;
SHORT attno;
{
	switch (attribute[attno]->type)
	{
	case name:
		if (value.ivalue == UK_INT)
			fprintf(stream, "? ");
		else
			fprintf(stream, "%s ", id_value(value.ivalue, attno)->name);
		break;
	case ivalue:
		if (value.ivalue == UK_INT)
			fprintf(stream, "? ");
		else
			fprintf(stream, "%d ", value.ivalue);
		break;
	case fvalue:
		if (value.fvalue == UK_FLOAT)
			fprintf(stream, "? ");
		else
			fprintf(stream, "%5.1f ", value.fvalue);
		break;
	}
}
                                                                    */
input_type_error(type_found)
InputType type_found;
{
     fprintf(stdout,  "ERROR: wrong type of file\n");
     fprintf(stdout, "   Type expected: ");
     print_input_type(stdout, input_type);
     fprintf(stdout, "   Type found: ");
     print_input_type(stdout, type_found);
}


 
num_class_error()
{
     fprintf(stdout,
	     "ERROR: CN2 doesn't handle numeric classes.\n");
     fprintf(stdout,
	     "You must either discretise the class attribute, \n");
     fprintf(stdout,
	     "or use NewId instead.\n\n");
     errflag = TRUE;
}


int yyexca[] ={
-1, 1,
	0, -1,
	-2, 0,
-1, 13,
	257, 22,
	-2, 19,
-1, 14,
	257, 22,
	-2, 19,
-1, 15,
	0, 25,
	-2, 23,
-1, 18,
	268, 15,
	-2, 14,
-1, 26,
	280, 25,
	-2, 23,
-1, 31,
	0, 24,
	280, 24,
	-2, 42,
-1, 76,
	289, 70,
	-2, 71,
-1, 94,
	289, 77,
	-2, 71,
-1, 158,
	293, 88,
	-2, 87,
	};
# define YYNPROD 109
# define YYLAST 255
int yyact[]={

   165,   166,    80,    82,    81,    60,   146,   161,   129,   106,
   105,   104,   103,   114,    41,    40,   117,    71,    61,    20,
   134,   133,   132,   153,   151,   135,   116,    52,    92,    91,
    87,    88,   152,   138,    90,    89,   167,    53,    83,    45,
    47,    46,    64,    57,    26,    25,    29,    30,   121,   155,
    62,   115,    36,   130,   131,   111,    85,   156,    48,    49,
    77,    78,     9,    10,    11,   144,    12,   165,   166,   126,
   143,   125,    74,    75,   157,   147,   137,   128,   120,   158,
   149,   126,   142,   113,   102,   100,    99,    67,    39,    52,
   164,   148,   124,   123,   107,    66,    96,    44,    51,    38,
    32,    22,    17,   136,   127,   119,   112,    98,    79,   163,
   162,   160,   159,   139,   109,   154,   140,    21,   122,   118,
    97,    95,    94,    93,    76,    50,    34,    24,    35,    16,
    65,    55,    42,    59,    58,    43,    33,    56,    72,    70,
    69,    86,    68,    23,    28,    19,    54,    27,    18,    63,
    15,    14,    13,     8,     7,     6,     5,    73,     4,     3,
     2,    84,     1,    37,    31,   101,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
   110,   108,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,   141,     0,     0,   145,     0,
     0,     0,   150,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
     0,     0,     0,     0,   168 };
int yypact[]={

 -1000, -1000,  -198, -1000, -1000, -1000, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,  -270,  -270, -1000,  -235,  -236, -1000, -1000,
  -228, -1000, -1000, -1000, -1000, -1000, -1000,  -216,  -169,  -275,
  -276, -1000, -1000,  -218,  -168,  -243, -1000,  -169, -1000,  -238,
 -1000, -1000, -1000,  -277, -1000, -1000, -1000, -1000, -1000, -1000,
  -230, -1000,  -239, -1000, -1000,  -170, -1000,  -272, -1000,  -218,
 -1000,  -186,  -205, -1000,  -255,  -170, -1000,  -211, -1000, -1000,
 -1000,  -244, -1000, -1000,  -253,  -254, -1000, -1000, -1000, -1000,
 -1000, -1000, -1000,  -171, -1000,  -172,  -173,  -278,  -279,  -280,
  -281, -1000, -1000, -1000, -1000, -1000, -1000,  -214,  -174, -1000,
  -269,  -231, -1000, -1000, -1000, -1000, -1000, -1000, -1000,  -273,
 -1000, -1000,  -180, -1000, -1000, -1000, -1000,  -225,  -188,  -181,
 -1000,  -282,  -217, -1000,  -264,  -260, -1000,  -182,  -248, -1000,
 -1000,  -188,  -175,  -189,  -194,  -176,  -288, -1000,  -183,  -177,
  -177, -1000, -1000, -1000, -1000,  -261, -1000,  -249, -1000,  -263,
  -223,  -202,  -184,  -178, -1000, -1000, -1000, -1000, -1000,  -286,
 -1000, -1000,  -191,  -258, -1000, -1000, -1000, -1000, -1000 };
int yypgo[]={

     0,   165,   164,   163,   162,   160,   159,   158,   156,   155,
   154,   153,   152,   102,   101,   151,   150,   148,   147,   146,
   145,   144,   143,    99,   142,   141,   140,   139,   138,   100,
   136,   135,   134,    97,   133,   131,   130,    95,   129,   127,
   126,   125,   124,   123,   122,    94,   121,    96,   120,   119,
   118,   116,    91,   115,   114,   113,    93,    92,   112,   111,
   110,   109,    90,    98,   108,   107,   106,   105,   104,   103 };
int yyr1[]={

     0,     5,     4,     6,     6,     6,     6,     6,    12,     7,
    15,     8,    16,     9,    13,    18,    13,    21,    17,    17,
    20,    20,    20,    22,    14,    14,     3,     3,    25,    23,
    23,    23,    24,    24,    24,    28,    27,    26,     1,     1,
     2,     2,    30,    29,    32,    32,    32,    31,    34,    31,
    33,    33,    33,    33,    33,    35,    19,    36,    36,    37,
    38,    10,    40,    39,    42,    42,    43,    43,    44,    44,
    46,    48,    49,    51,    47,    53,    53,    54,    55,    45,
    50,    50,    56,    56,    56,    56,    57,    52,    58,    52,
    60,    59,    61,    61,    62,    62,    41,    41,    63,    63,
    63,    63,    64,    65,    66,    67,    68,    69,    11 };
int yyr2[]={

     0,     1,     4,     2,     2,     2,     2,     2,     1,    13,
     1,     7,     1,     7,     3,     1,     8,     1,     7,     1,
     7,     7,     1,     1,     5,     1,     5,     3,     1,    13,
     7,     7,     7,     7,     3,     0,     6,     6,     3,     5,
     3,     5,     1,     7,     3,     7,     7,     2,     1,     6,
     3,     3,     3,     3,     3,     1,     5,     4,     2,     9,
     1,     7,     1,    12,     3,     3,     4,     4,     2,     4,
     0,     1,     1,     1,    16,     2,     1,     1,     1,    12,
     2,     6,     7,     7,     7,    11,     3,     7,     1,    10,
     1,     8,     2,     4,     3,     3,     4,     2,     6,     7,
     7,     7,    14,     2,     2,     2,    10,     2,     1 };
int yychk[]={

 -1000,    -4,    -5,    -6,    -7,    -8,    -9,   -10,   -11,   260,
   261,   262,   264,   -12,   -15,   -16,   -38,   -13,   -17,   -20,
   289,   -13,   -14,   -22,   -39,   280,   280,   -18,   -21,   274,
   275,    -2,   -29,   -30,   -40,   -14,   268,    -3,   -23,   257,
   290,   290,   -29,   -31,   -33,   257,   259,   258,   276,   277,
   -41,   -63,   257,   280,   -19,   -35,   -23,   281,   -32,   -34,
   282,   295,   280,   -63,   281,   -36,   -37,   257,   -24,   -26,
   -27,   289,   -28,   -33,   258,   259,   -42,   265,   266,   -64,
   257,   259,   258,   293,   -37,   267,   -25,   274,   275,   279,
   278,   282,   282,   -43,   -44,   -46,   -47,   -48,   -65,   257,
   257,    -1,   257,   290,   290,   290,   290,   -45,   -47,   -54,
   -45,   269,   -66,   257,   282,   282,   257,   289,   -49,   -67,
   258,   273,   -50,   -56,   -57,   259,   257,   -68,   258,   290,
   270,   271,   286,   285,   284,   285,   -69,   258,   281,   -55,
   -51,   -56,   257,   259,   259,   -57,   294,   258,   -52,   257,
   -52,   285,   281,   286,   -53,   272,   259,   258,   257,   -58,
   -59,   293,   -60,   -61,   -62,   258,   259,   294,   -62 };
int yydef[]={

     1,    -2,   108,     2,     3,     4,     5,     6,     7,     8,
    10,    12,    60,    -2,    -2,    -2,     0,     0,    -2,    17,
     0,    11,    13,    42,    61,    62,    -2,     0,     0,     0,
     0,    -2,    40,     0,     0,     0,    55,    18,    27,     0,
    20,    21,    41,    48,    47,    50,    51,    52,    53,    54,
     0,    97,     0,     9,    16,     0,    26,    35,    43,     0,
    44,     0,     0,    96,     0,    56,    58,     0,    28,    30,
    31,     0,    34,    49,     0,     0,    -2,    64,    65,    98,
    99,   100,   101,     0,    57,     0,     0,     0,     0,     0,
     0,    45,    46,    63,    -2,    77,    68,     0,     0,   103,
     0,     0,    38,    32,    33,    36,    37,    66,    69,     0,
    67,    72,     0,   104,    59,    29,    39,     0,     0,     0,
   105,     0,     0,    80,     0,     0,    86,     0,     0,    78,
    73,     0,     0,     0,     0,     0,     0,   107,     0,     0,
     0,    81,    82,    83,    84,     0,   102,     0,    79,     0,
    76,     0,     0,     0,    74,    75,    85,   106,    -2,     0,
    89,    90,     0,     0,    92,    94,    95,    91,    93 };
typedef struct { char *t_name; int t_val; } yytoktype;
#ifndef YYDEBUG
#	define YYDEBUG	0	/* don't allow debugging */
#endif

#if YYDEBUG

yytoktype yytoks[] =
{
	"STRING",	257,
	"INTEGER_TOKEN",	258,
	"FLOAT_TOKEN",	259,
	"BOTH_FILE_HEADER",	260,
	"ATTRIBUTE_FILE_HEADER",	261,
	"EXAMPLE_FILE_HEADER",	262,
	"TREE_FILE_HEADER",	263,
	"RULE_FILE_HEADER",	264,
	"ORDERED_RULE_TOKEN",	265,
	"UNORDERED_RULE_TOKEN",	266,
	"BEFORE_TOKEN",	267,
	"ORDERING_TOKEN",	268,
	"IF_TOKEN",	269,
	"THEN_TOKEN",	270,
	"AND_TOKEN",	271,
	"ELSE_TOKEN",	272,
	"DEFAULT_TOKEN",	273,
	"BINARY_TOKEN",	274,
	"MULTIPLE_TOKEN",	275,
	"DONT_CARE",	276,
	"UNKNOWN",	277,
	"FLOAT_TYPE",	278,
	"INTEGER_TYPE",	279,
	"SEPARATOR",	280,
	"COLON",	281,
	"EOE_CHAR",	282,
	"LEQ",	283,
	"GE",	284,
	"LE",	285,
	"EQUALS",	286,
	"NULL_DECISION",	287,
	"CLASH_DECISION",	288,
	"OPEN_PARENTHESIS",	289,
	"CLOSE_PARENTHESIS",	290,
	"OPEN_BRACKET",	291,
	"CLOSE_BRACKET",	292,
	"OPEN_SQUARE",	293,
	"CLOSE_SQUARE",	294,
	"W_TOKEN",	295,
	"-unknown-",	-1	/* ends search */
};

char * yyreds[] =
{
	"-no such reduction-",
	"input : /* empty */",
	"input : input_file",
	"input_file : both_file",
	"input_file : attribute_file",
	"input_file : example_file",
	"input_file : rule_file",
	"input_file : rubbish",
	"both_file : BOTH_FILE_HEADER",
	"both_file : BOTH_FILE_HEADER attributes_etc SEPARATOR all_examples SEPARATOR",
	"attribute_file : ATTRIBUTE_FILE_HEADER",
	"attribute_file : ATTRIBUTE_FILE_HEADER attributes_etc",
	"example_file : EXAMPLE_FILE_HEADER",
	"example_file : EXAMPLE_FILE_HEADER all_examples",
	"attributes_etc : all_attributes",
	"attributes_etc : all_attributes",
	"attributes_etc : all_attributes ORDERING_TOKEN attribute_ordering",
	"all_attributes : binary_flag",
	"all_attributes : binary_flag att_declarations",
	"all_attributes : /* empty */",
	"binary_flag : OPEN_PARENTHESIS BINARY_TOKEN CLOSE_PARENTHESIS",
	"binary_flag : OPEN_PARENTHESIS MULTIPLE_TOKEN CLOSE_PARENTHESIS",
	"binary_flag : /* empty */",
	"all_examples : /* empty */",
	"all_examples : examples",
	"all_examples : /* empty */",
	"att_declarations : att_declarations att_declaration",
	"att_declarations : att_declaration",
	"att_declaration : STRING COLON binary_att_flag",
	"att_declaration : STRING COLON binary_att_flag att_vals EOE_CHAR",
	"att_declaration : STRING COLON float_type",
	"att_declaration : STRING COLON integer_type",
	"binary_att_flag : OPEN_PARENTHESIS BINARY_TOKEN CLOSE_PARENTHESIS",
	"binary_att_flag : OPEN_PARENTHESIS MULTIPLE_TOKEN CLOSE_PARENTHESIS",
	"binary_att_flag : empty",
	"empty : /* empty */",
	"integer_type : OPEN_PARENTHESIS INTEGER_TYPE CLOSE_PARENTHESIS",
	"float_type : OPEN_PARENTHESIS FLOAT_TYPE CLOSE_PARENTHESIS",
	"att_vals : STRING",
	"att_vals : att_vals STRING",
	"examples : example",
	"examples : examples example",
	"example : /* empty */",
	"example : example_values example_terminator",
	"example_terminator : EOE_CHAR",
	"example_terminator : W_TOKEN INTEGER_TOKEN EOE_CHAR",
	"example_terminator : W_TOKEN FLOAT_TOKEN EOE_CHAR",
	"example_values : example_value",
	"example_values : example_values",
	"example_values : example_values example_value",
	"example_value : STRING",
	"example_value : FLOAT_TOKEN",
	"example_value : INTEGER_TOKEN",
	"example_value : DONT_CARE",
	"example_value : UNKNOWN",
	"attribute_ordering : /* empty */",
	"attribute_ordering : att_orders",
	"att_orders : att_orders att_order",
	"att_orders : att_order",
	"att_order : STRING BEFORE_TOKEN STRING EOE_CHAR",
	"rule_file : RULE_FILE_HEADER",
	"rule_file : RULE_FILE_HEADER root",
	"root : SEPARATOR",
	"root : SEPARATOR rule_parameters SEPARATOR rule_type_declaration all_rules",
	"rule_type_declaration : ORDERED_RULE_TOKEN",
	"rule_type_declaration : UNORDERED_RULE_TOKEN",
	"all_rules : rule_list default_rule",
	"all_rules : empty_rule_list default_rule",
	"rule_list : rule",
	"rule_list : rule_list rule",
	"empty_rule_list : /* empty */",
	"rule : /* empty */",
	"rule : IF_TOKEN",
	"rule : IF_TOKEN premise THEN_TOKEN",
	"rule : IF_TOKEN premise THEN_TOKEN conclusion rule_separator",
	"rule_separator : ELSE_TOKEN",
	"rule_separator : /* empty */",
	"default_rule : /* empty */",
	"default_rule : OPEN_PARENTHESIS DEFAULT_TOKEN CLOSE_PARENTHESIS",
	"default_rule : OPEN_PARENTHESIS DEFAULT_TOKEN CLOSE_PARENTHESIS conclusion",
	"premise : condition",
	"premise : premise AND_TOKEN condition",
	"condition : att_string EQUALS STRING",
	"condition : att_string LE FLOAT_TOKEN",
	"condition : att_string GE FLOAT_TOKEN",
	"condition : FLOAT_TOKEN LE att_string LE FLOAT_TOKEN",
	"att_string : STRING",
	"conclusion : STRING EQUALS STRING",
	"conclusion : STRING EQUALS STRING",
	"conclusion : STRING EQUALS STRING count_array",
	"count_array : OPEN_SQUARE",
	"count_array : OPEN_SQUARE count_numbers CLOSE_SQUARE",
	"count_numbers : count_number",
	"count_numbers : count_numbers count_number",
	"count_number : INTEGER_TOKEN",
	"count_number : FLOAT_TOKEN",
	"rule_parameters : rule_parameters rule_parameter",
	"rule_parameters : rule_parameter",
	"rule_parameter : STRING COLON time_stamp",
	"rule_parameter : STRING COLON STRING",
	"rule_parameter : STRING COLON FLOAT_TOKEN",
	"rule_parameter : STRING COLON INTEGER_TOKEN",
	"time_stamp : OPEN_SQUARE weekday month day time year CLOSE_SQUARE",
	"weekday : STRING",
	"month : STRING",
	"day : INTEGER_TOKEN",
	"time : INTEGER_TOKEN COLON INTEGER_TOKEN COLON INTEGER_TOKEN",
	"year : INTEGER_TOKEN",
	"rubbish : /* empty */",
};
#endif /* YYDEBUG */
#line 1 "/usr/lib/yaccpar"
/*	@(#)yaccpar 1.10 89/04/04 SMI; from S5R3 1.10	*/

/*
** Skeleton parser driver for yacc output
*/

/*
** yacc user known macros and defines
*/
#define YYERROR		goto yyerrlab
#define YYACCEPT	{ free(yys); free(yyv); return(0); }
#define YYABORT		{ free(yys); free(yyv); return(1); }
#define YYBACKUP( newtoken, newvalue )\
{\
	if ( yychar >= 0 || ( yyr2[ yytmp ] >> 1 ) != 1 )\
	{\
		yyerror( "syntax error - cannot backup" );\
		goto yyerrlab;\
	}\
	yychar = newtoken;\
	yystate = *yyps;\
	yylval = newvalue;\
	goto yynewstate;\
}
#define YYRECOVERING()	(!!yyerrflag)
#ifndef YYDEBUG
#	define YYDEBUG	1	/* make debugging available */
#endif

/*
** user known globals
*/
int yydebug;			/* set to 1 to get debugging */

/*
** driver internal defines
*/
#define YYFLAG		(-1000)

/*
** static variables used by the parser
*/
static YYSTYPE *yyv;			/* value stack */
static int *yys;			/* state stack */

static YYSTYPE *yypv;			/* top of value stack */
static int *yyps;			/* top of state stack */

static int yystate;			/* current state */
static int yytmp;			/* extra var (lasts between blocks) */

int yynerrs;			/* number of errors */

int yyerrflag;			/* error recovery flag */
int yychar;			/* current input token number */


/*
** yyparse - return 0 if worked, 1 if syntax error not recovered from
*/
int
yyparse()
{
	register YYSTYPE *yypvt;	/* top of value stack for $vars */
	unsigned yymaxdepth = YYMAXDEPTH;

	/*
	** Initialize externals - yyparse may be called more than once
	*/
	yyv = (YYSTYPE*)malloc(yymaxdepth*sizeof(YYSTYPE));
	yys = (int*)malloc(yymaxdepth*sizeof(int));
	if (!yyv || !yys)
	{
		yyerror( "out of memory" );
		return(1);
	}
	yypv = &yyv[-1];
	yyps = &yys[-1];
	yystate = 0;
	yytmp = 0;
	yynerrs = 0;
	yyerrflag = 0;
	yychar = -1;

	goto yystack;
	{
		register YYSTYPE *yy_pv;	/* top of value stack */
		register int *yy_ps;		/* top of state stack */
		register int yy_state;		/* current state */
		register int  yy_n;		/* internal state number info */

		/*
		** get globals into registers.
		** branch to here only if YYBACKUP was called.
		*/
	yynewstate:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;
		goto yy_newstate;

		/*
		** get globals into registers.
		** either we just started, or we just finished a reduction
		*/
	yystack:
		yy_pv = yypv;
		yy_ps = yyps;
		yy_state = yystate;

		/*
		** top of for (;;) loop while no reductions done
		*/
	yy_stack:
		/*
		** put a state and value onto the stacks
		*/
#if YYDEBUG
		/*
		** if debugging, look up token value in list of value vs.
		** name pairs.  0 and negative (-1) are special values.
		** Note: linear search is used since time is not a real
		** consideration while debugging.
		*/
		if ( yydebug )
		{
			register int yy_i;

			(void)printf( "State %d, token ", yy_state );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ++yy_ps >= &yys[ yymaxdepth ] )	/* room on stack? */
		{
			/*
			** reallocate and recover.  Note that pointers
			** have to be reset, or bad things will happen
			*/
			int yyps_index = (yy_ps - yys);
			int yypv_index = (yy_pv - yyv);
			int yypvt_index = (yypvt - yyv);
			yymaxdepth += YYMAXDEPTH;
			yyv = (YYSTYPE*)realloc((char*)yyv,
				yymaxdepth * sizeof(YYSTYPE));
			yys = (int*)realloc((char*)yys,
				yymaxdepth * sizeof(int));
			if (!yyv || !yys)
			{
				yyerror( "yacc stack overflow" );
				return(1);
			}
			yy_ps = yys + yyps_index;
			yy_pv = yyv + yypv_index;
			yypvt = yyv + yypvt_index;
		}
		*yy_ps = yy_state;
		*++yy_pv = yyval;

		/*
		** we have a new state - find out what to do
		*/
	yy_newstate:
		if ( ( yy_n = yypact[ yy_state ] ) <= YYFLAG )
			goto yydefault;		/* simple state */
#if YYDEBUG
		/*
		** if debugging, need to mark whether new token grabbed
		*/
		yytmp = yychar < 0;
#endif
		if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
			yychar = 0;		/* reached EOF */
#if YYDEBUG
		if ( yydebug && yytmp )
		{
			register int yy_i;

			(void)printf( "Received token " );
			if ( yychar == 0 )
				(void)printf( "end-of-file\n" );
			else if ( yychar < 0 )
				(void)printf( "-none-\n" );
			else
			{
				for ( yy_i = 0; yytoks[yy_i].t_val >= 0;
					yy_i++ )
				{
					if ( yytoks[yy_i].t_val == yychar )
						break;
				}
				(void)printf( "%s\n", yytoks[yy_i].t_name );
			}
		}
#endif /* YYDEBUG */
		if ( ( ( yy_n += yychar ) < 0 ) || ( yy_n >= YYLAST ) )
			goto yydefault;
		if ( yychk[ yy_n = yyact[ yy_n ] ] == yychar )	/*valid shift*/
		{
			yychar = -1;
			yyval = yylval;
			yy_state = yy_n;
			if ( yyerrflag > 0 )
				yyerrflag--;
			goto yy_stack;
		}

	yydefault:
		if ( ( yy_n = yydef[ yy_state ] ) == -2 )
		{
#if YYDEBUG
			yytmp = yychar < 0;
#endif
			if ( ( yychar < 0 ) && ( ( yychar = yylex() ) < 0 ) )
				yychar = 0;		/* reached EOF */
#if YYDEBUG
			if ( yydebug && yytmp )
			{
				register int yy_i;

				(void)printf( "Received token " );
				if ( yychar == 0 )
					(void)printf( "end-of-file\n" );
				else if ( yychar < 0 )
					(void)printf( "-none-\n" );
				else
				{
					for ( yy_i = 0;
						yytoks[yy_i].t_val >= 0;
						yy_i++ )
					{
						if ( yytoks[yy_i].t_val
							== yychar )
						{
							break;
						}
					}
					(void)printf( "%s\n", yytoks[yy_i].t_name );
				}
			}
#endif /* YYDEBUG */
			/*
			** look through exception table
			*/
			{
				register int *yyxi = yyexca;

				while ( ( *yyxi != -1 ) ||
					( yyxi[1] != yy_state ) )
				{
					yyxi += 2;
				}
				while ( ( *(yyxi += 2) >= 0 ) &&
					( *yyxi != yychar ) )
					;
				if ( ( yy_n = yyxi[1] ) < 0 )
					YYACCEPT;
			}
		}

		/*
		** check for syntax error
		*/
		if ( yy_n == 0 )	/* have an error */
		{
			/* no worry about speed here! */
			switch ( yyerrflag )
			{
			case 0:		/* new error */
				yyerror( "syntax error" );
				goto skip_init;
			yyerrlab:
				/*
				** get globals into registers.
				** we have a user generated syntax type error
				*/
				yy_pv = yypv;
				yy_ps = yyps;
				yy_state = yystate;
				yynerrs++;
			skip_init:
			case 1:
			case 2:		/* incompletely recovered error */
					/* try again... */
				yyerrflag = 3;
				/*
				** find state where "error" is a legal
				** shift action
				*/
				while ( yy_ps >= yys )
				{
					yy_n = yypact[ *yy_ps ] + YYERRCODE;
					if ( yy_n >= 0 && yy_n < YYLAST &&
						yychk[yyact[yy_n]] == YYERRCODE)					{
						/*
						** simulate shift of "error"
						*/
						yy_state = yyact[ yy_n ];
						goto yy_stack;
					}
					/*
					** current state has no shift on
					** "error", pop stack
					*/
#if YYDEBUG
#	define _POP_ "Error recovery pops state %d, uncovers state %d\n"
					if ( yydebug )
						(void)printf( _POP_, *yy_ps,
							yy_ps[-1] );
#	undef _POP_
#endif
					yy_ps--;
					yy_pv--;
				}
				/*
				** there is no state on stack with "error" as
				** a valid shift.  give up.
				*/
				YYABORT;
			case 3:		/* no shift yet; eat a token */
#if YYDEBUG
				/*
				** if debugging, look up token in list of
				** pairs.  0 and negative shouldn't occur,
				** but since timing doesn't matter when
				** debugging, it doesn't hurt to leave the
				** tests here.
				*/
				if ( yydebug )
				{
					register int yy_i;

					(void)printf( "Error recovery discards " );
					if ( yychar == 0 )
						(void)printf( "token end-of-file\n" );
					else if ( yychar < 0 )
						(void)printf( "token -none-\n" );
					else
					{
						for ( yy_i = 0;
							yytoks[yy_i].t_val >= 0;
							yy_i++ )
						{
							if ( yytoks[yy_i].t_val
								== yychar )
							{
								break;
							}
						}
						(void)printf( "token %s\n",
							yytoks[yy_i].t_name );
					}
				}
#endif /* YYDEBUG */
				if ( yychar == 0 )	/* reached EOF. quit */
					YYABORT;
				yychar = -1;
				goto yy_newstate;
			}
		}/* end if ( yy_n == 0 ) */
		/*
		** reduction by production yy_n
		** put stack tops, etc. so things right after switch
		*/
#if YYDEBUG
		/*
		** if debugging, print the string that is the user's
		** specification of the reduction which is just about
		** to be done.
		*/
		if ( yydebug )
			(void)printf( "Reduce by (%d) \"%s\"\n",
				yy_n, yyreds[ yy_n ] );
#endif
		yytmp = yy_n;			/* value to switch over */
		yypvt = yy_pv;			/* $vars top of value stack */
		/*
		** Look in goto table for next state
		** Sorry about using yy_state here as temporary
		** register variable, but why not, if it works...
		** If yyr2[ yy_n ] doesn't have the low order bit
		** set, then there is no action to be done for
		** this reduction.  So, no saving & unsaving of
		** registers done.  The only difference between the
		** code just after the if and the body of the if is
		** the goto yy_stack in the body.  This way the test
		** can be made before the choice of what to do is needed.
		*/
		{
			/* length of production doubled with extra bit */
			register int yy_len = yyr2[ yy_n ];

			if ( !( yy_len & 01 ) )
			{
				yy_len >>= 1;
				yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
				yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
					*( yy_ps -= yy_len ) + 1;
				if ( yy_state >= YYLAST ||
					yychk[ yy_state =
					yyact[ yy_state ] ] != -yy_n )
				{
					yy_state = yyact[ yypgo[ yy_n ] ];
				}
				goto yy_stack;
			}
			yy_len >>= 1;
			yyval = ( yy_pv -= yy_len )[1];	/* $$ = $1 */
			yy_state = yypgo[ yy_n = yyr1[ yy_n ] ] +
				*( yy_ps -= yy_len ) + 1;
			if ( yy_state >= YYLAST ||
				yychk[ yy_state = yyact[ yy_state ] ] != -yy_n )
			{
				yy_state = yyact[ yypgo[ yy_n ] ];
			}
		}
					/* save until reenter driver code */
		yystate = yy_state;
		yyps = yy_ps;
		yypv = yy_pv;
	}
	/*
	** code supplied by user is placed in this switch
	*/
	switch( yytmp )
	{
		
case 1:
# line 77 "ingest.y"
{ ln = 1; } break;
case 8:
# line 91 "ingest.y"
{
                if (input_type == ATTRIBUTES_AND_EXAMPLES){
		     fprintf(stdout,
			     "Reading attributes and examples...\n");
		}
		else {
		     input_type_error(ATTRIBUTES_AND_EXAMPLES);
   		     YYERROR;
		}
	      } break;
case 9:
# line 105 "ingest.y"
{ fprintf(stdout, "%d examples!\n", (int) number_of_examples);
                fprintf(stdout,
			"Finished reading attribute and example file!\n"); } break;
case 10:
# line 113 "ingest.y"
{
                if (input_type == ATTRIBUTES){
		     fprintf(stdout,
			     "Reading attributes...\n");
		}
		else {
		     input_type_error(ATTRIBUTES);
   		     YYERROR;
		}
	      } break;
case 11:
# line 124 "ingest.y"
{ fprintf(stdout, "Finished reading attribute file!\n");
	      } break;
case 12:
# line 129 "ingest.y"
{
                 if (input_type == EXAMPLES){
		     fprintf(stdout,
			     "Reading examples...\n");
		}
		else {
		     input_type_error(EXAMPLES);
   		     YYERROR;
		}
	      } break;
case 13:
# line 140 "ingest.y"
{ fprintf(stdout, "%d examples!\n", (int) number_of_examples);
                fprintf(stdout, "Finished reading example file!\n"); } break;
case 14:
# line 146 "ingest.y"
{
#ifdef DEBUG_INPUT
                fprintf(stdout, "No order declarations.\n"); 
#endif
	      } break;
case 15:
# line 152 "ingest.y"
{
#ifdef DEBUG_INPUT
                fprintf(stdout, "Order declarations....\n"); 
#endif
	      } break;
case 17:
# line 162 "ingest.y"
{  errflag = FALSE;      
	       attribute_list = new_listelement();
	       attr_ptr = &attribute_list;
	       att_num = 0;} break;
case 18:
# line 167 "ingest.y"
{ number_of_attributes = yypvt[-0].ival;  /* att_declarations */
#ifdef DEBUG_INPUT
	       fprintf(stdout, "I reckon there were %d attributes\n\n",
		                                      number_of_attributes);
#endif
	       FREE(*attr_ptr);
               (*attr_ptr) = (List)0;
   	       IDclass = (last(attribute_list)) -> head -> value;
	       if (ATT_TYPE(IDclass) == ORDERED_TYPE) 
		 num_class_error();
	       number_of_classes = N_VALUES(IDclass);
	       
	       if (errflag) {
		    fprintf(stdout, "Aborting parse.\n");
		    YYERROR;
	       }
	       else
		 setup_attribute_array();
	      } break;
case 19:
# line 189 "ingest.y"
{    fprintf(stdout, "ERROR: No attributes declarations\n");
	      fprintf(stdout, "Aborting parse.\n");
	      YYERROR;
	 } break;
case 20:
# line 197 "ingest.y"
{
#ifdef DEBUG_INPUT
	              fprintf(stdout, "Default discrete split is binary\n");
#endif
		      default_binary_flag = TWOWAY; } break;
case 21:
# line 203 "ingest.y"
{
#ifdef DEBUG_INPUT
	              fprintf(stdout, "Default discrete split is multiple\n");
#endif
		      default_binary_flag = MULTIPLE; } break;
case 22:
# line 208 "ingest.y"
{
#ifdef DEBUG_INPUT
	              fprintf(stdout, "No default split declaration,\n");
	              fprintf(stdout, "so default will be multiple.\n");
#endif
	              default_binary_flag = MULTIPLE; } break;
case 23:
# line 217 "ingest.y"
{  errflag = FALSE;
		ukdc_flag = FALSE;
	        example_list = new_elistelement();
	        e_ptr = &example_list;  } break;
case 24:
# line 222 "ingest.y"
{ (*e_ptr) = (EList)0;
	       number_of_examples = (long ) 1 + yypvt[-0].ival;    /* examples */
	       ex_ptr_array = (EList *) ALLOC((number_of_examples + 1)
					      * sizeof(EList));
               if (errflag) {
		    fprintf(stdout, "Aborting parse.\n");
		    YYERROR;
	       }
	      } break;
case 25:
# line 234 "ingest.y"
{    fprintf(stdout, "ERROR: No examples\n");
	      fprintf(stdout, "Aborting parse.\n");
	      YYERROR;
	 } break;
case 26:
# line 243 "ingest.y"
{yyval.ival = yypvt[-1].ival + 1;} break;
case 27:
# line 245 "ingest.y"
{ yyval.ival = 1; } break;
case 28:
# line 249 "ingest.y"
{ value_list = new_listelement();
		     value_ptr = &value_list; } break;
case 29:
# line 252 "ingest.y"
{ ((*attr_ptr) -> head) = new_object();
#ifdef DEBUG_INPUT
                   fprintf(stdout, "\nAttribute:%s\n", yypvt[-5].sval);
#endif
                  ((*attr_ptr) -> head -> value) =       /* att_vals */  
   		    new_attribute(intern(yypvt[-5].sval), DISCRETE_TYPE, 0, yypvt[-1].ival, value_list, att_num);
                  ((*attr_ptr) -> head -> otype) =  ATTRIBUTE_TYPE;
                  ((Attribute *)((*attr_ptr) -> head -> value))->bin_action =
		    current_binary_flag;
		  
		  (*attr_ptr) -> tail = new_listelement();
                  attr_ptr = &((*attr_ptr) -> tail); 
		  att_num++;
#ifdef DEBUG_INPUT
                   fprintf(stdout, "\n");
#endif
    	        } break;
case 30:
# line 270 "ingest.y"
{  ((*attr_ptr) -> head) = new_object();

#ifdef DEBUG_INPUT
                   fprintf(stdout, "\nAttribute:%s FLOAT\n", yypvt[-2].sval);
#endif		  
                  ((*attr_ptr) -> head -> value) =
		     new_attribute(intern(yypvt[-2].sval), ORDERED_TYPE, REAL, 2, (List)NULL, att_num);
                  ((*attr_ptr) -> head -> otype) =  ATTRIBUTE_TYPE;  
                  ((Attribute *)((*attr_ptr) -> head -> value))->bin_action =
		    MULTIPLE;
		  (*attr_ptr) -> tail = new_listelement();		  
                   attr_ptr = &((*attr_ptr) -> tail);
		   att_num++; } break;
case 31:
# line 284 "ingest.y"
{  ((*attr_ptr) -> head) = new_object();
                  ((*attr_ptr) -> head -> value) =
  		     new_attribute(intern(yypvt[-2].sval), ORDERED_TYPE, INTEGRAL, 2, (List)NULL, att_num);
                  ((*attr_ptr) -> head -> otype) =  ATTRIBUTE_TYPE;
                  ((Attribute *)((*attr_ptr) -> head -> value))->bin_action =
		    MULTIPLE;		  
		  (*attr_ptr) -> tail = new_listelement();		  
                   attr_ptr = &((*attr_ptr) -> tail);
		   att_num++; } break;
case 32:
# line 297 "ingest.y"
{
#ifdef DEBUG_INPUT
	          fprintf(stdout, "Binary split coming up...\n");
#endif
		  current_binary_flag = TWOWAY; } break;
case 33:
# line 303 "ingest.y"
{
#ifdef DEBUG_INPUT
	          fprintf(stdout, "Multiple split coming up...\n");
#endif
		  current_binary_flag = MULTIPLE; } break;
case 34:
# line 309 "ingest.y"
{ current_binary_flag = default_binary_flag; } break;
case 38:
# line 323 "ingest.y"
{  add_att_val(yypvt[-0].sval);
                 yyval.ival = 1;
              } break;
case 39:
# line 327 "ingest.y"
{  add_att_val(yypvt[-0].sval);
                 yyval.ival = yypvt[-1].ival + 1;
              } break;
case 40:
# line 332 "ingest.y"
{yyval.ival = 0;} break;
case 41:
# line 333 "ingest.y"
{yyval.ival = yypvt[-1].ival + 1;} break;
case 42:
# line 337 "ingest.y"
{ att_num = 0;
		  attr_ptr = &attribute_list;
	          current_attr = (Attribute *) (*attr_ptr) -> head -> value;
		  ex_errflag = FALSE; } break;
case 43:
# line 342 "ingest.y"
{ if (! (att_num == (number_of_attributes-1)))
		    attr_num_error(ln, att_num, number_of_attributes);
		  (*e_ptr)->next = new_elistelement();
	          e_ptr = &((*e_ptr) -> next);
#ifdef DEBUG_INPUT
		  fprintf(stdout, "\n");
#endif
	        } break;
case 44:
# line 354 "ingest.y"
{(*e_ptr)->weight = 1.0;} break;
case 45:
# line 358 "ingest.y"
{(*e_ptr)->weight = (float) yypvt[-1].ival;} break;
case 46:
# line 361 "ingest.y"
{(*e_ptr)->weight = yypvt[-1].fval;} break;
case 48:
# line 368 "ingest.y"
{
			  if (att_num++ > (number_of_attributes - 2))
			    ex_errflag = TRUE;			     
			  if (! ex_errflag) {
			       attr_ptr = &((*attr_ptr) -> tail);
			       current_attr = (Attribute *)
				   (*attr_ptr) -> head -> value;
		          }
		     } break;
case 50:
# line 382 "ingest.y"
{if (! ex_errflag) {
		if (((current_attr ->atype) == DISCRETE_TYPE)
		     && value_id(intern(yypvt[-0].sval), att_num,
				  (&(*e_ptr) -> values[att_num].d))){
#ifdef DEBUG_INPUT		     
		     fprintf(stdout, "%d:", att_num);
		     fprintf(stdout, "%s ", yypvt[-0].sval);
#endif
		    }
		      else
			attr_error(ln, att_num,yypvt[-0].sval);
 		    }
	           } break;
case 51:
# line 395 "ingest.y"
{if (! ex_errflag) {
	               if ((current_attr -> atype) == ORDERED_TYPE)
			 (*e_ptr) -> values[att_num].o = yypvt[-0].fval;
		       else {
			    sprintf(temp, "%f", yypvt[-0].fval);
			    attr_error(ln, att_num, temp);
		       }
		    }
                   } break;
case 52:
# line 404 "ingest.y"
{if (! ex_errflag) {
	               if ((current_attr->atype) == ORDERED_TYPE){
#ifdef DEBUG_INPUT		     
			 fprintf(stdout, "%d:", att_num);
		         fprintf(stdout, "%d ", yypvt[-0].ival);
#endif			 
			 (*e_ptr) -> values[att_num].o = (float) yypvt[-0].ival;
		       }
		       else {
			    sprintf(temp, "%d", yypvt[-0].ival);		      
			    attr_error(ln, att_num, temp);
		       }
		    }
	           } break;
case 53:
# line 418 "ingest.y"
{if (! ex_errflag) {
	               ukdc_flag = TRUE;
	               if (att_num == (number_of_attributes-1)) 
			      dc_error(ln);		       
	               switch (current_attr -> atype){
		       case ORDERED_TYPE:
			    (*e_ptr) -> values[att_num].o = DC_FLOAT;
#ifdef DEBUG_INPUT		     
			    fprintf(stdout, "%d:", att_num);
			    fprintf(stdout, "DONT_CARE ");
#endif			    			    
			    break;
		       case DISCRETE_TYPE:
			    (*e_ptr) -> values[att_num].d = DC_INT;
#ifdef DEBUG_INPUT		     
			    fprintf(stdout, "%d:", att_num);
			    fprintf(stdout, "DONT_CARE ");
#endif			    
			    break;
		       }
		    }
		 } break;
case 54:
# line 440 "ingest.y"
{if (! ex_errflag) {
	               if (att_num == (number_of_attributes-1)) 
			    uk_error(ln);	      
	               ukdc_flag = TRUE;	      
	               switch (current_attr -> atype){
		       case ORDERED_TYPE:
			    (*e_ptr) -> values[att_num].o = UK_FLOAT;
#ifdef DEBUG_INPUT		     
			    fprintf(stdout, "%d:", att_num);
			    fprintf(stdout, "UNKNOWN ");
#endif			    			    
			    break;
		       case DISCRETE_TYPE:
			    (*e_ptr) -> values[att_num].d = UK_INT;
#ifdef DEBUG_INPUT		     
			    fprintf(stdout, "%d:", att_num);
			    fprintf(stdout, "UNKNOWN ");
#endif			    			    
			    break;
		       }
		    }
	       } break;
case 55:
# line 466 "ingest.y"
{ initialise_order_array(); } break;
case 56:
# line 468 "ingest.y"
{ transform_order_array(); } break;
case 59:
# line 477 "ingest.y"
{
#ifdef DEBUG_INPUT
	     fprintf(stdout, "%s before %s\n", yypvt[-3].sval, yypvt[-1].sval);
#endif	     
	     insert_order_array(yypvt[-3].sval,yypvt[-1].sval);
	} break;
case 60:
# line 489 "ingest.y"
{
                if (input_type == RULES){
		     fprintf(stdout,
			     "Reading rules...\n");
		}
		else {
		     input_type_error(RULES);
   		     YYERROR;
		}
	      } break;
case 61:
# line 500 "ingest.y"
{ fprintf(stdout, "Finished reading rules!\n"); } break;
case 62:
# line 505 "ingest.y"
{ init_rule_reader(); } break;
case 64:
# line 513 "ingest.y"
{ algorithm_flag |= A_ORDERED;
#ifdef DEBUG_INPUT		     
		 fprintf(stdout, "Rules will be Ordered\n");
#endif
	    } break;
case 65:
# line 521 "ingest.y"
{ algorithm_flag &= ~A_ORDERED;
#ifdef DEBUG_INPUT		     
		 fprintf(stdout, "Rules will be Un-Ordered\n");
#endif
	    } break;
case 71:
# line 542 "ingest.y"
{ add_rule(); } break;
case 72:
# line 544 "ingest.y"
{
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "If ");
#endif
	    } break;
case 73:
# line 551 "ingest.y"
{
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "Then ");
#endif
	    } break;
case 76:
# line 561 "ingest.y"
{  } break;
case 77:
# line 566 "ingest.y"
{
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "Default Rule:\n");
#endif
	    } break;
case 78:
# line 572 "ingest.y"
{ add_rule(); } break;
case 82:
# line 584 "ingest.y"
{
		if (((current_attr ->atype) == DISCRETE_TYPE)
		     && value_id(intern(yypvt[-0].sval), att_num, &att_val)){
#ifdef DEBUG_INPUT		     
		     fprintf(stdout, "= %s\n ", yypvt[-0].sval);
#endif
		     if (! (current_rule -> selector)[att_num].discriminant)
		       (current_rule -> selector)[att_num].discriminant =
			 new_discriminant(nth_attribute(att_num));
		
		     (current_rule -> selector)[att_num].discriminant->attval =
                      att_val;
		     (current_rule -> selector)[att_num].setp =
		       TOTAL_INSTANTIATION;
		}
		      else
			attr_error(ln, att_num,yypvt[-0].sval);
          } break;
case 83:
# line 606 "ingest.y"
{
                     if (! (current_rule -> selector)[att_num].discriminant)
		       (current_rule -> selector)[att_num].discriminant =
			 new_discriminant(nth_attribute(att_num));

		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->instantiation = UPPER_BOUND;
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->upper = yypvt[-0].fval;
		     (current_rule -> selector)[att_num].setp = INSTANTIATION;
#ifdef DEBUG_INPUT		     
		     fprintf(stdout, "< %.2f\n ", yypvt[-0].fval);
#endif
                 } break;
case 84:
# line 623 "ingest.y"
{
		     if (! (current_rule -> selector)[att_num].discriminant)
		       (current_rule -> selector)[att_num].discriminant =
			 new_discriminant(nth_attribute(att_num));
		      
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->instantiation = LOWER_BOUND;
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->lower = yypvt[-0].fval;
		     (current_rule -> selector)[att_num].setp = INSTANTIATION;
#ifdef DEBUG_INPUT		     
		     fprintf(stdout, "> %.2f\n ", yypvt[-0].fval);
#endif
                 } break;
case 85:
# line 641 "ingest.y"
{
		     if (! (current_rule -> selector)[att_num].discriminant)
		       (current_rule -> selector)[att_num].discriminant =
			 new_discriminant(nth_attribute(att_num));
			
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->instantiation = DOUBLE_BOUND;
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->upper = yypvt[-0].fval;
		     (current_rule -> selector)[att_num].discriminant
		       ->bounds->lower = yypvt[-4].fval;		     
		     (current_rule -> selector)[att_num].setp =
		       TOTAL_INSTANTIATION;
#ifdef DEBUG_INPUT		     
		     fprintf(stdout, "between %.2f and %.2f\n", yypvt[-4].fval, yypvt[-0].fval);
#endif
                 } break;
case 86:
# line 663 "ingest.y"
{  if (current_attr = string_to_attribute(yypvt[-0].sval)){
	     att_num = ATT_NO(current_attr);
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "%s ", yypvt[-0].sval);
#endif	     
        }
     else
       YYERROR;
       } break;
case 87:
# line 675 "ingest.y"
{
	     errflag |= ! value_id(string_to_atom(yypvt[-0].sval),
				   ATT_NO(IDclass),
				   &(current_rule->class));
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "%s = %s\n ", yypvt[-2].sval, yypvt[-0].sval);
#endif	     	     
	} break;
case 88:
# line 686 "ingest.y"
{
	     errflag |= ! value_id(string_to_atom(yypvt[-0].sval),
				   ATT_NO(IDclass),
				   &(current_rule->class));
#ifdef DEBUG_INPUT		     
	     fprintf(stdout, "%s = %s\n ", yypvt[-2].sval, yypvt[-0].sval);
#endif
	     current_rule->distribution = (double *) ALLOC(number_of_classes *
					  sizeof(double));
        } break;
case 90:
# line 699 "ingest.y"
{
#ifdef DEBUG_INPUT
                fprintf(stdout, "Found a count_array!\n");
		fflush(stdout);		
#endif       
                count_index = 0;
	      } break;
case 94:
# line 715 "ingest.y"
{ current_rule->distribution[count_index++] = (double) yypvt[-0].ival;
#ifdef DEBUG_INPUT
                fprintf(stdout, "INTEGER ");
                fprintf(stdout, "Index %d, Count %f\n",
			count_index-1,
			current_rule->distribution[count_index-1]);
		fflush(stdout);	       
#endif
             } break;
case 95:
# line 728 "ingest.y"
{ current_rule->distribution[count_index++] = (double) yypvt[-0].fval;
#ifdef DEBUG_INPUT
                fprintf(stdout, "FLOAT %.2f  ", yypvt[-0].fval);	       
                fprintf(stdout, "Index %d, Count %f\n",
			count_index-1,
			current_rule->distribution[count_index-1]);
		fflush(stdout);	       
#endif
	     } break;
case 99:
# line 755 "ingest.y"
{ rule_par_sread(yypvt[-2].sval, yypvt[-0].sval);} break;
case 100:
# line 760 "ingest.y"
{ rule_par_fread(yypvt[-2].sval, yypvt[-0].fval);} break;
case 101:
# line 765 "ingest.y"
{ rule_par_nread(yypvt[-2].sval, yypvt[-0].ival);} break;
case 108:
# line 785 "ingest.y"
{ input_type_error(ERROR);
	   YYERROR;} break;
	}
	goto yystack;		/* reset registers in driver code */
}
